/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CouponProvider type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CouponProvider{}

// CouponProvider struct for CouponProvider
type CouponProvider struct {
	StampCards []StampCard `json:"stamp_cards,omitempty"`
}

// NewCouponProvider instantiates a new CouponProvider object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCouponProvider() *CouponProvider {
	this := CouponProvider{}
	return &this
}

// NewCouponProviderWithDefaults instantiates a new CouponProvider object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCouponProviderWithDefaults() *CouponProvider {
	this := CouponProvider{}
	return &this
}

// GetStampCards returns the StampCards field value if set, zero value otherwise.
func (o *CouponProvider) GetStampCards() []StampCard {
	if o == nil || IsNil(o.StampCards) {
		var ret []StampCard
		return ret
	}
	return o.StampCards
}

// GetStampCardsOk returns a tuple with the StampCards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponProvider) GetStampCardsOk() ([]StampCard, bool) {
	if o == nil || IsNil(o.StampCards) {
		return nil, false
	}
	return o.StampCards, true
}

// HasStampCards returns a boolean if a field has been set.
func (o *CouponProvider) HasStampCards() bool {
	if o != nil && !IsNil(o.StampCards) {
		return true
	}

	return false
}

// SetStampCards gets a reference to the given []StampCard and assigns it to the StampCards field.
func (o *CouponProvider) SetStampCards(v []StampCard) {
	o.StampCards = v
}

func (o CouponProvider) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CouponProvider) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.StampCards) {
		toSerialize["stamp_cards"] = o.StampCards
	}
	return toSerialize, nil
}

type NullableCouponProvider struct {
	value *CouponProvider
	isSet bool
}

func (v NullableCouponProvider) Get() *CouponProvider {
	return v.value
}

func (v *NullableCouponProvider) Set(val *CouponProvider) {
	v.value = val
	v.isSet = true
}

func (v NullableCouponProvider) IsSet() bool {
	return v.isSet
}

func (v *NullableCouponProvider) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCouponProvider(val *CouponProvider) *NullableCouponProvider {
	return &NullableCouponProvider{value: val, isSet: true}
}

func (v NullableCouponProvider) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCouponProvider) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


